rawset(_G,"CA_WALLHOOK", 18)

local function P_FlyTo(mo, fx, fy, fz, sped, addques) --A very useful command honestly.
	if mo.valid
		local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
		if flyto < 1
			flyto = 1
		end
		local anglesucc = R_PointToAngle2(mo.x, mo.y, fx, fy)
		
		if addques
			mo.momx = $ + FixedMul(FixedDiv(fx - mo.x, flyto), sped)
			mo.momy = $ + FixedMul(FixedDiv(fy - mo.y, flyto), sped)
			mo.momz = $ + FixedMul(FixedDiv(fz - mo.z, flyto), sped)
		else
			mo.momx = FixedMul(FixedDiv(fx - mo.x, flyto), sped)
			mo.momy = FixedMul(FixedDiv(fy - mo.y, flyto), sped)
			mo.momz = FixedMul(FixedDiv(fz - mo.z, flyto), sped)
		end	
	end	
end

freeslot("S_WALLHOOK_CHAIN","S_WALLHOOK_HOOK","SPR_WLCH", "MT_WALLHOOK")
mobjinfo[MT_WALLHOOK] = {
	spawnstate = S_WALLHOOK_HOOK,
	deathstate = S_WALLHOOK_HOOK,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	speed = 60*FRACUNIT,
	flags = MF_STICKY|MF_MISSILE|MF_PAPERCOLLISION
}
states[S_WALLHOOK_CHAIN] = {SPR_WLCH, A,-1,nil,0,0,S_NULL}
states[S_WALLHOOK_HOOK] = {SPR_WLCH, B|FF_PAPERSPRITE|FF_TRANS30|FF_ADD,TICRATE,nil,0,0,S_NULL}

local function DrawLine(mo,mobj,x1,y1,z1,x2,y2,z2)
	local onem = z1
	local twom = z2
	
	local cd = R_PointToDist2(x1,y1,x2,y2)
	local ca = R_PointToAngle2(x1,y1,x2,y2)
	local cdz = twom-onem
	local caz = R_PointToAngle2(0, 0, cd, cdz)
	local cad = P_AproxDistance(P_AproxDistance(x2-x1,y2-y1),twom-onem)
	
	local cf = cad/FRACUNIT/50
	if cf > 50
		cf = 50
	end
	
	local prevc
	for i = 1, cf
		local cx = P_ReturnThrustX(nil, ca, (cd/cf)*i)
		local cy = P_ReturnThrustY(nil, ca, (cd/cf)*i)
		local cz = (cdz/cf)*i
	
		local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_PARTICLE)
		P_MoveOrigin(t, x1+cx, y1+cy, onem+cz)
		t.state = S_WALLHOOK_CHAIN
		t.fuse = 3
		t.color = mo.color
		if prevc and prevc.valid
			t.angle = R_PointToAngle2(t.x,t.y,prevc.x,prevc.y)
		else
			t.angle = R_PointToAngle2(t.x,t.y,mobj.x,mobj.y)
		end
		
		prevc = t
	end
end

addHook("AbilitySpecial", function(player)
	if player.valid and player.mo and player.mo.valid
	and not player.spectator and player.playerstate == PST_LIVE
	and player.charability == CA_WALLHOOK
		if (player.si_wallstuff
		and player.si_wallstuff.walljump)
		or (player.pflags & PF_THOKKED)
			return
		end
		player.wallhook.attach = false
		player.wallhook.hook = P_SPMAngle(player.mo,MT_WALLHOOK,player.mo.angle)
		if player.wallhook.hook and player.wallhook.hook.valid
			local hook = player.wallhook.hook
			hook.scale = player.mo.scale*2
			hook.angle = $+ANGLE_90
			hook.color = ColorOpposite(player.mo.color)
			hook.fuse = -1
			hook.tics = -1
			
			hook.momz = abs(player.mo.momz)*P_MobjFlip(player.mo)
			S_StartSoundAtVolume(hook,sfx_s3k4b,100)
		end
		
		player.pflags = $|PF_THOKKED
	end
end)

addHook("PlayerThink", function(player)
	if player.valid and player.mo and player.mo.valid
	and not player.spectator and player.playerstate == PST_LIVE
	and player.charability == CA_WALLHOOK
		if not player.wallhook
			player.wallhook = {}
		end
		if player.wallhook.hook and player.wallhook.hook.valid
			local hook = player.wallhook.hook
			
			local cx = hook.x-player.mo.x
			local cy = hook.y-player.mo.y
			local cz = hook.z-(player.mo.z+player.mo.height/2)
			local zd = P_AproxDistance(P_AproxDistance(cx,cy),cz)
			
			if not (hook.flags2 & MF2_BEYONDTHEGRAVE)
				if (hook.momx and hook.momy and hook.momz) == 0
					P_FlyTo(player.mo,hook.x,hook.y,hook.z+hook.height/2,abs(zd)/20,true)
					
					if (player.pflags & PF_THOKKED)
						player.pflags = $&~PF_THOKKED
					end
					if not player.wallhook.attach
						if S_SoundPlaying(hook,sfx_s3k4b)
							S_StopSoundByID(hook,sfx_s3k4b)
						end
						S_StartSound(hook,sfx_s3k4a)
					end
					player.wallhook.attach = true
				else
					player.wallhook.attach = false
				end
				
				local rz = (player.mo.height/2)
				DrawLine(player.mo,hook,
					player.mo.x +player.mo.momx, player.mo.y +player.mo.momy, player.mo.z +player.mo.momz +rz,
					hook.x +hook.momx, hook.y +hook.momy, hook.z +hook.momz)
			end
			
			if (player.si_wallstuff
			and player.si_wallstuff.touchwall)
			or P_IsObjectOnGround(player.mo)
			or player.powers[pw_carry]
			or (zd > 720*player.mo.scale)
			or (zd <= player.mo.radius*3/2)
			or (not (player.cmd.buttons & BT_JUMP))
				P_KillMobj(hook)
				
				local g = P_SpawnGhostMobj(hook)
				g.destscale = hook.scale*10
				g.colorized = true
				g.blendmode = AST_ADD
				
				hook.state = S_NULL
				player.wallhook.hook = nil
				player.wallhook.attach = false
			end
		else
			player.wallhook.attach = false
		end
	end
end)

addHook("MobjMoveBlocked", function(mo,mobj,line)
	if mo and mo.valid
		if line and line.valid
			if line.angle
				mo.angle = line.angle
			end
		end
	end
end,MT_WALLHOOK)